package com.liang.dao;

import com.liang.entity.PrjProject;
import com.liang.entity.StaReimbursement;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * 报账(StaReimbursement)表数据库访问层
 *
 * @author makejava
 * @since 2023-05-16 13:06:38
 */
public interface StaReimbursementDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    StaReimbursement queryById(Integer id);

    /**
     * 通过FYSQ查询单条数据
     *
     * @param fysq
     * @return
     */
    StaReimbursement queryByFYSQ(Integer fysq);

    /**
     * 查询指定行数据
     *
     * @param staReimbursement 查询条件
     * @param pageable         分页对象
     * @return 对象列表
     */
    List<StaReimbursement> queryAllByLimit(StaReimbursement staReimbursement, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param staReimbursement 查询条件
     * @return 总行数
     */
    long count(StaReimbursement staReimbursement);

    /**
     * 新增数据
     *
     * @param staReimbursement 实例对象
     * @return 影响行数
     */
    int insert(StaReimbursement staReimbursement);

    /**
     * 撤销数据（基本信息）
     *
     * @param staReimbursement 实例对象
     * @return 影响行数
     */
    int tjrevokeApprove(StaReimbursement staReimbursement);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<StaReimbursement> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<StaReimbursement> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<StaReimbursement> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<StaReimbursement> entities);

    /**
     * 修改数据
     *
     * @param staReimbursement 实例对象
     * @return 影响行数
     */
    int update(StaReimbursement staReimbursement);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 获取报账列表
     *
     * @return
     */
    List<StaReimbursement> getReimburseList(Map map);

    /**
     * 批量删除报账
     *
     * @param idList
     * @return
     */
    int batchDelete(List<Integer> idList);

    /**
     * 修改审批状态
     *
     * @param staReimbursement 实例对象
     * @return 实例对象
     */
    int updateSpzt(StaReimbursement staReimbursement);

    /**
     * 老板修改报账
     *
     * @param staReimbursement 实例对象
     * @return 影响行数
     */
    int updateBZJE(StaReimbursement staReimbursement);

    Integer getRwsIdByBzId(Integer bzID);

    List<String> getYearList();

    int tjrevokeApprove1(StaReimbursement bzrxm);

    String getfysqmc(Integer id);


    List<String> getYears();
}

